adt.hpp File Reference
`#include <msgpack/preprocessor/config/config.hpp>`
`#include <msgpack/preprocessor/detail/is_binary.hpp>`
`#include <msgpack/preprocessor/logical/compl.hpp>`
`#include <msgpack/preprocessor/tuple/eat.hpp>`

Go to the source code of this file.

## Macros

#define | MSGPACK_PP_LIST_CONS(head, tail) (head, tail)
#define | MSGPACK_PP_LIST_NIL MSGPACK_PP_NIL
#define | MSGPACK_PP_LIST_FIRST(list) MSGPACK_PP_LIST_FIRST_D(list)
#define | MSGPACK_PP_LIST_FIRST_D(list) MSGPACK_PP_LIST_FIRST_I ## list
#define | MSGPACK_PP_LIST_FIRST_I(head, tail) head
#define | MSGPACK_PP_LIST_REST(list) MSGPACK_PP_LIST_REST_D(list)
#define | MSGPACK_PP_LIST_REST_D(list) MSGPACK_PP_LIST_REST_I ## list
#define | MSGPACK_PP_LIST_REST_I(head, tail) tail
#define | MSGPACK_PP_LIST_IS_CONS(list) MSGPACK_PP_IS_BINARY(list)
#define | MSGPACK_PP_LIST_IS_NIL(list) MSGPACK_PP_COMPL(MSGPACK_PP_LIST_IS_CONS(list))

## Macro Definition Documentation

## MSGPACK_PP_LIST_CONS

#define MSGPACK_PP_LIST_CONS | ( |  | head,
|  |  | tail
| ) |  | (head, tail)

## MSGPACK_PP_LIST_FIRST

#define MSGPACK_PP_LIST_FIRST | ( |  | list | ) | MSGPACK_PP_LIST_FIRST_D(list)

## MSGPACK_PP_LIST_FIRST_D

#define MSGPACK_PP_LIST_FIRST_D | ( |  | list | ) | MSGPACK_PP_LIST_FIRST_I ## list

## MSGPACK_PP_LIST_FIRST_I

#define MSGPACK_PP_LIST_FIRST_I | ( |  | head,
|  |  | tail
| ) |  | head

## MSGPACK_PP_LIST_IS_CONS

#define MSGPACK_PP_LIST_IS_CONS | ( |  | list | ) | MSGPACK_PP_IS_BINARY(list)

## MSGPACK_PP_LIST_IS_NIL

#define MSGPACK_PP_LIST_IS_NIL | ( |  | list | ) | MSGPACK_PP_COMPL(MSGPACK_PP_LIST_IS_CONS(list))

## MSGPACK_PP_LIST_NIL

#define MSGPACK_PP_LIST_NIL MSGPACK_PP_NIL

## MSGPACK_PP_LIST_REST

#define MSGPACK_PP_LIST_REST | ( |  | list | ) | MSGPACK_PP_LIST_REST_D(list)

## MSGPACK_PP_LIST_REST_D

#define MSGPACK_PP_LIST_REST_D | ( |  | list | ) | MSGPACK_PP_LIST_REST_I ## list

## MSGPACK_PP_LIST_REST_I

#define MSGPACK_PP_LIST_REST_I | ( |  | head,
|  |  | tail
| ) |  | tail